
import scala.compat.Platform.currentTime
import scala.io.Source

val fname = "words.txt"

class GrowArray {
  private var A = new Array[String](32)
  private var cursize = 0

  def capacity: Int = A.length
  def length: Int = cursize
  def apply(i: Int): String = A(i)
  def update(i: Int, s: String) = { A(i) = s }
  def append(s: String) = {
    if (length == capacity) {
      val B = A
      A = new Array[String](B.length + 32)
      for (i <- 0 until B.length)
	A(i) = B(i)
    }
    A(cursize) = s
    cursize += 1
  }
}

def readWords(): GrowArray = {
  val F = Source.fromFile(fname)
  var A = new GrowArray
  for (line <- F.getLines()) {
    A.append(line)
  }
  A
}

println("Starting...")
val t0 = currentTime
val A = readWords()
val t1 = currentTime
printf("Reading all %d words took %d milliseconds\n", A.length, t1 - t0)

println
println("The first ten words are:")
for (i <- 0 until 10)
  println(A(i))

